/*
	Includes
*/
#include "stdint.h"
#include "functions.h"
#include "stm32f4xx_conf.h"
#include "ctype.h"

/*
	Defines
*/
#define CAPS_LOCK_CODE 0x58     // Macro fr Caps Lock scan code
#define LOWER 0       				  // Macro fr 0
#define UPPER 1      					  // Macro fr 1

#define XMT_ENABLE  GPIO_Pin_15
#define XMT_D3 GPIO_Pin_3
#define XMT_D2 GPIO_Pin_2
#define XMT_D1 GPIO_Pin_1
#define XMT_D0 GPIO_Pin_0

/*
	Globale Variablen
*/
ps2_type ps2;	// Struktur fr Verabeitung der PS2-Daten
 

char char_case = LOWER;
int bk=0;		// break - Variable


const char _ascii_key[128] =   // Table for decode 
{
    0      // 0x00
    , 0     // 0x01       
    , 0     // 0x02   
    , 0     // 0x03 
    , 0     // 0x04 
    , 0     // 0x05 
    , 0     // 0x06 
    , 0     // 0x07 
    , 0     // 0x08 
    , 0    // 0x09 
    , 0     // 0x0A 
    , 0     // 0x0B 
    , 0     // 0x0C 
    , 11     // 0x0D 
    , 0     // 0x0E 
    , 0     // 0x0F 
    , 0     // 0x10 
    , 0     // 0x11 
    , 0     // 0x12 
    , 0     // 0x13 
    , 0     // 0x14 
    , 'q'     // 0x15 
    , '!'     // 0x16 
    , 0     // 0x17 
    , 0     // 0x18 
    , 0     // 0x19 
    , 'z'     // 0x1A 
    , 's'     // 0x1B 
    , 'a'      // 0x1C
    , 'w'     // 0x1D 
    , '@'     // 0x1E 
    , 0     // 0x1F 
    , 0     // 0x20 
    , 'c'     // 0x21 
    , 'x'     // 0x22 
    , 'd'     // 0x23 
    , 'e'     // 0x24 
    , '$'     // 0x25 
    , '#'     // 0x26 
    , 0     // 0x27 
    , 0     // 0x28 
    , 32     // 0x29 
    , 'v'     // 0x2A 
    , 'f'     // 0x2B 
    , 't'     // 0x2C 
    , 'r'     // 0x2D 
    , '%'     // 0x2E 
    , 0     // 0x2F 
    , 0     // 0x30 
    , 'n'     // 0x31 
    , 'b'     // 0x32 
    , 'h'     // 0x33 
    , 'g'     // 0x34 
    , 'y'     // 0x35 
    , '^'     // 0x36 
    , 0     // 0x37 
    , 0     // 0x38 
    , 0     // 0x39 
    , 'm'     // 0x3A 
    , 'j'     // 0x3B 
    , 'u'     // 0x3C 
    , '&'     // 0x3D 
    , '*'     // 0x3E 
    , 0     // 0x3F 
    , 0     // 0x40 
    , 44     // 0x41 
    , 'k'     // 0x42 
    , 'i'     // 0x43 
    , 'o'     // 0x44 
    , ')'     // 0x45 
    , '('     // 0x46 
    , 0     // 0x47 
    , 0     // 0x48 
    , '.'     // 0x49 
    , '/'     // 0x4A 
    , 'l'     // 0x4B 
    , ';'     // 0x4C 
    , 'p'     // 0x4D 
    , '-'     // 0x4E 
    , 0     // 0x4F
    , 0     // 0x50 
    , 0     // 0x51 
    , 39     // 0x52 
    , 0     // 0x53 
    , 0     // 0x54 
    , '='     // 0x55 
    , 0     // 0x56 
    , 0     // 0x57 
    , 0     // 0x58 
    , 0     // 0x59 
    , 13     // 0x5A 
    , ']'     // 0x5B 
    , 0     // 0x5C 
    , 92     // 0x5D 
    , 0     // 0x5E 
    , 0     // 0x5F 
    , 0     // 0x60 
    , 0     // 0x61 
    , 0     // 0x62 
    , 0     // 0x63 
    , 0     // 0x64 
    , 0     // 0x65 
    , 8     // 0x66 
    , 0     // 0x67 
    , 0     // 0x68 
    , '1'     // 0x69 
    , 0     // 0x6A 
    , '4'     // 0x6B 
    , '7'     // 0x6C 
    , 0     // 0x6D 
    , 0     // 0x6E 
    , 0     // 0x6F
    , '0'     // 0x70 
    , '.'     // 0x71 
    , '2'     // 0x72 
    , '5'     // 0x73 
    , '6'     // 0x74 
    , '8'     // 0x75 
    , 27     // 0x76 
    , 0     // 0x77 
    , 0     // 0x78 
    , '+'     // 0x79 
    , '3'     // 0x7A 
    , '-'     // 0x7B 
    , '*'     // 0x7C 
    , '9'     // 0x7D 
    , 0     // 0x7E 
    , 0     // 0x7F

};

/**
  * @brief  wait - Funktion					
  * @param  None
  * @retval None
  */
void wait_ms(int ms) {
	
	int i, j;
	
	for(j=0;j<ms;j++) {
	for(i=0;i<40000;i++) {}
	}

}


/**
  * @brief  Enableleitung wird kurz auf 1 (Daten gueltig) und dann wieder auf 0 gesetzt
  * @param  None
  * @retval None
  */
void EN_pulse(void) {

	GPIO_SetBits(GPIOC, XMT_ENABLE);	// Enableleitung auf 1 setzen
	
	wait_ms(10);
	
	GPIO_ResetBits(GPIOC, XMT_ENABLE);	// Enableleitung wieder auf 0 setzen
	
}


/**
  * @brief  Zeichen ber die parallele Leitung senden			
  * @param  None
  * @retval None
  */
void XMT_senddata(char c) {
	
	if (c&0x80)GPIO_SetBits(GPIOC, XMT_D3);else GPIO_ResetBits(GPIOC,XMT_D3);	// ueberpruefe ob 1. Bit gesetzt
	if (c&0x40)GPIO_SetBits(GPIOC, XMT_D2);else GPIO_ResetBits(GPIOC,XMT_D2);	// ueberpruefe ob 2. Bit gesetzt
	if (c&0x20)GPIO_SetBits(GPIOC, XMT_D1);else GPIO_ResetBits(GPIOC,XMT_D1);	// ueberpruefe ob 3. Bit gesetzt
	if (c&0x10)GPIO_SetBits(GPIOC, XMT_D0);else GPIO_ResetBits(GPIOC,XMT_D0);	// ueberpruefe ob 4. Bit gesetzt
	
	EN_pulse();	// Enable-Leitung wird kurz auf 1 und dann wieder auf 0 gesetzt
	
	if (c&0x08)GPIO_SetBits(GPIOC, XMT_D3);else GPIO_ResetBits(GPIOC,XMT_D3);	// ueberpruefe ob 5. Bit gesetzt
	if (c&0x04)GPIO_SetBits(GPIOC, XMT_D2);else GPIO_ResetBits(GPIOC,XMT_D2);	// ueberpruefe ob 6. Bit gesetzt
	if (c&0x02)GPIO_SetBits(GPIOC, XMT_D1);else GPIO_ResetBits(GPIOC,XMT_D1);	// ueberpruefe ob 7. Bit gesetzt
	if (c&0x01)GPIO_SetBits(GPIOC, XMT_D0);else GPIO_ResetBits(GPIOC,XMT_D0);	// ueberpruefe ob 8. Bit gesetzt
	
	EN_pulse();	// Enable-Leitung wird kurz auf 1 und dann wieder auf 0 gesetzt
	
}


/**
  * @brief  Die Daten von der PS2 Tastatur werden in Asciizeichen umgewandelt		
  * @param  None
  * @retval None
  */
char ScanToChar(unsigned char KeyCode)
{
    if (bk==1)	// bk ist beim Zweiten Aufruf des Break-Codes = 1 -> bk wird auf 0 gesetzt und 0 wird zurueckgegeben
    {
        bk=0;
        return 0;
    }
    
    // Beim Uebertragen vom ersten Teil des Break-Codes, wird bk auf 1 gesetzt und 0 zurueckgegeben
    if (KeyCode == 0xF0 || KeyCode == 0xE0 || KeyCode == 0xE1) // Ignoriere Break, Make and Pause  
    {
        bk=1;
        return 0;
    }
    // durch die beiden if-Anweisungen wird sichergestellt, dass nur der Make-Code weiter uebertragen wird
    
    else
    {   
        if(KeyCode == CAPS_LOCK_CODE)  // Check Caps Lock mode key push?
        {
            char_case ^=1;  // Toggle bit - Capslock aktivieren bzw. deaktivieren
            return 0;
        }
				
        // Backspace
        if(KeyCode == 0x66)
        {
            return 0x08;
        }
				
        // Enter
        if(KeyCode == 0x5A)
        {
            return 0;
        }
				
        // Jede andere Taste
        if(char_case==UPPER)  // Ueberpruefen ob Capslock aktiv -> 'A'-'Z'
            return toupper(_ascii_key[KeyCode]); // Grobuchstaben werden uebergeben 'A'-'Z'
				
        else
            return _ascii_key[KeyCode];  // Kleinbuchstaben werden uebergeben 'a'-'z'
				
    }
}


/**
  * @brief  Daten der PS2 Tastatur werden fuer den Transfer aufbereitet			
  * @param  None
  * @retval None
  */
void ps2_data(void)
{
		char temp='x';	// Variable temp wird mit 'x' initialisiert

    if (GPIO_ReadInputDataBit(GPIOE, GPIO_Pin_9))   // Ueberpruefe ob 1 bei Pin E9 anliegt
    {
        ps2.input |= 0x8000;	// 0x8000 -> 1000... (Erstes Bit ist 1) - Oder-Verknuepfung
    }
    ps2.input = ps2.input >> 1;		// Bit-shift nach rechts um eine Stelle
    ps2.counter++;		// zaehlt von 1 - 11 (11 Bits werden bertragen)

    if (ps2.counter == 11)	// Ueberpruefen ob alle 11 Bits uebertragen wurden 
    {   
        ps2.input >>= 5; // 5 Bit nach rechts, damit Daten ab Stelle 0, Start Bit wird hinausgeschoben
        
        temp=ScanToChar(ps2.input);	// Ps2-Code in ASCI umwandeln
        
        if (temp!=0)	// Falls temp nicht Null ist, werden die Daten gesendet
        {
					XMT_senddata(temp);	// Daten senden
					wait_ms(10);
        }
    
				// Variablen wieder Rcksetzen
        ps2.counter=0;
        ps2.input=0;
    }
}
